//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPBaseTypes.h"

// Remove override keyword if not supported
#ifndef CDP_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif

// Makes it easier to check on the current GCC version
#ifdef __GNUC__
// 40302 means version 4.3.2.
#define CDPHL_GCC_VER  (__GNUC__*10000 + __GNUC_MINOR__*100 + __GNUC_PATCHLEVEL__)
#endif  


// Helper macro to disable (ignore) compiler warnings on GCC
// The needed pragma is only available in GCC for versions 4.2.x and above
#if defined(__GNUC__) && (CDPHL_GCC_VER >= 40200)
#define CDPHL_DO_PRAGMA(x) _Pragma(#x)
#define CDPHL_GCC_DIAGNOSTIC_IGNORE(OPTION_STRING) CDPHL_DO_PRAGMA(GCC diagnostic ignored OPTION_STRING)
#else
#define CDPHL_GCC_DIAGNOSTIC_IGNORE(OPTION_STRING) 
#endif


