//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPPlugin.h"
#include "CDPDataProvider.h"
#include "CDPDataProviderFactory.h"

#include <string>

namespace cdphl {


//==================================================================================================
//
// 
//
//==================================================================================================
class DataProviderFactory
{
public:
    DataProviderFactory(int sequenceNumber, const char* providerIdString, CDPDataProviderFactory* providerFactoryFromPlugin, CDP_DestroyProviderFactoryFunc destroyProviderFactoryFunc);
    ~DataProviderFactory();

    int                 sequenceNumber() const;
    std::string         providerId() const;

    bool                getProviderInfo(CDPDataProviderInfo* info);
    bool                isSupportedByProvider(const CDPString& modelKey);

    CDPDataProvider*    createProviderInstance();
    void                destroyProviderInstance(CDPDataProvider* instance);

private:
    int                             m_sequenceNumber;
    std::string                     m_idString;
    CDPDataProviderFactory*         m_providerFactoryFromPlugin;
    CDP_DestroyProviderFactoryFunc  m_destroyProviderFactoryFunc;
};


}
