//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlDataProviderInfo.h"

namespace cdphl {

//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void DataProviderInfo::setFileDescription(const CDPString& description)
{
    m_fileDescription = description;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void DataProviderInfo::setFileMask(const CDPString& mask)
{
    m_fileMask = mask;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void DataProviderInfo::publishInitOptionBool(const CDPString& optionKey, const CDPString& optionDescription, bool defaultValue)
{
    InitOption opt;
    opt.key = optionKey;
    opt.description = optionDescription;
    opt.dataType = BOOL;
    opt.boolValue = defaultValue;
    
    m_initOptions.push_back(opt);
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void DataProviderInfo::publishInitOptionDouble(const CDPString& optionKey, const CDPString& optionDescription, cdp_double_t defaultValue)
{
    InitOption opt;
    opt.key = optionKey;
    opt.description = optionDescription;
    opt.dataType = DOUBLE;
    opt.doubleValue = defaultValue;
    
    m_initOptions.push_back(opt);
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void DataProviderInfo::publishInitOptionString(const CDPString& optionKey, const CDPString& optionDescription, const CDPString& defaultValue)
{
    InitOption opt;
    opt.key = optionKey;
    opt.description = optionDescription;
    opt.dataType = STRING;
    opt.stringValue = defaultValue;
    
    m_initOptions.push_back(opt);
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t DataProviderInfo::initOptionCount() const
{
    return m_initOptions.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const InitOption& DataProviderInfo::initOption(size_t index) const
{
    return m_initOptions[index];
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const CDPString& DataProviderInfo::fileDescription() const
{
    return m_fileDescription;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const CDPString& DataProviderInfo::fileMask() const
{
    return m_fileMask;
}
    
} // cdphl
