//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2020, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"

#include "CDPInitOptions.h"
#include "CDPString.h"

#include <string>
#include <map>

namespace cdphl {


//==================================================================================================
//
//
//
//==================================================================================================
class InitOptions : public CDPInitOptions
{
public:
    InitOptions();
    InitOptions(const InitOptions& other);
    InitOptions& operator=(const InitOptions& rhs);
    
    virtual bool                hasKey(const CDPString& optionKey) const override;
    
    virtual cdp_double_t        doubleValue(const CDPString& optionKey) const override;
    virtual bool                boolValue(const CDPString& optionKey) const override;
    virtual const CDPString&    stringValue(const CDPString& optionKey) const override;
    
    void                        setDoubleValue(const CDPString& optionKey, double value);
    void                        setBoolValue(const CDPString& optionKey, bool value);
    void                        setStringValue(const CDPString& optionKey, const CDPString& value);

private:
    std::map<std::string, double>       m_doubleKeyValueMap;
    std::map<std::string, bool>         m_boolKeyValueMap;
    std::map<std::string, CDPString>    m_stringKeyValueMap;
};

}
