//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlNodeGroup.h"
#include "cdphlAssert.h"

#include <set>

namespace cdphl {


//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
NodeGroup::NodeGroup(cdp_size_t groupIdx)
{
    m_groupIndex = groupIdx;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
NodeGroup::~NodeGroup()
{
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void NodeGroup::setNodes(const cdp_double_t* nodeArr, cdp_size_t nodeCount)
{
    m_nodeArr.reserve(3 * nodeCount);
    m_nodeArr.assign(nodeArr, nodeArr + 3*nodeCount);
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void NodeGroup::setNodeIds(const cdp_int_t* nodeIdArr, cdp_size_t nodeCount)
{
    m_nodeIdArr.reserve(nodeCount);
    m_nodeIdArr.assign(nodeIdArr, nodeIdArr + nodeCount);
}


//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
cdp_size_t NodeGroup::groupIndex() const
{
    return m_groupIndex;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const std::vector<cdp_double_t>& NodeGroup::nodeArr() const
{
    return m_nodeArr;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const std::vector<cdp_int_t>& NodeGroup::nodeIdArr() const
{
    return m_nodeIdArr;
}



}  // cdphl
