//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"

#include "CDPNodeGroup.h"

#include <vector>

namespace cdphl {


//==================================================================================================
//
// 
//
//==================================================================================================
class NodeGroup : public CDPNodeGroup
{
public:
    NodeGroup(cdp_size_t groupIdx);
    virtual ~NodeGroup();

    virtual void        setNodes(const cdp_double_t* nodeArr, cdp_size_t nodeCount) override;
    virtual void        setNodeIds(const cdp_int_t* nodeIdArr, cdp_size_t nodeCount) override;
    
    virtual cdp_size_t  groupIndex() const override;
    
    const std::vector<cdp_double_t>&    nodeArr() const;
    const std::vector<cdp_int_t>&       nodeIdArr() const;
    
private:
    std::vector<cdp_double_t>   m_nodeArr;
    std::vector<cdp_int_t>      m_nodeIdArr;
    cdp_size_t                  m_groupIndex;
};


}  // cdphl

