//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlResult.h"
#include "cdphlResultValueGroup.h"

namespace cdphl {



//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
Result::~Result()
{
    for (size_t i = 0; i < m_groupArr.size(); ++i)
    {
        delete m_groupArr[i];
    }
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
CDPResultValueGroup* Result::addGroup()
{
    ResultValueGroup* group = new ResultValueGroup;
    m_groupArr.push_back(group);
        
    return group;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t Result::groupCount() const
{
    return m_groupArr.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const ResultValueGroup& Result::group(size_t index) const
{
    return *m_groupArr[index];
}



//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
ResultSpec::ResultSpec()
    : m_geometryIndex(0),
    m_resultId(-1),
    m_stateId(-1)
{
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
ResultSpec::ResultSpec(cdp_size_t geometryIndex, cdp_int_t resultId, cdp_int_t stateId)
    : m_geometryIndex(geometryIndex),
    m_resultId(resultId),
    m_stateId(stateId)
{
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
cdp_int_t ResultSpec::stateId() const
{
    return m_stateId;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
cdp_size_t ResultSpec::geometryIndex() const
{
    return m_geometryIndex;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
cdp_int_t ResultSpec::resultId() const
{
    return m_resultId;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void ResultSpec::setStateId(cdp_int_t stateId)
{
    m_stateId = stateId;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void ResultSpec::setGeometryIndex(cdp_size_t geometryIndex)
{
    m_geometryIndex = geometryIndex;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void ResultSpec::setResultId(cdp_int_t resultId)
{
    m_resultId = resultId;
}


}  // cdphl
