//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"

#include "CDPResult.h"

#include <vector>

namespace cdphl {

class ResultValueGroup;


//==================================================================================================
//
// 
//
//==================================================================================================
class Result : public CDPResult
{
public:
    virtual ~Result();
    
    virtual CDPResultValueGroup*    addGroup() override;
    
    size_t                          groupCount() const;
    const ResultValueGroup&         group(size_t index) const;
    
private:
    std::vector<ResultValueGroup*> m_groupArr;
};



//==================================================================================================
//
// 
//
//==================================================================================================
class ResultSpec : public CDPResultSpec
{
public:
    ResultSpec();
    ResultSpec(cdp_size_t geometryIndex, cdp_int_t resultId, cdp_int_t stateId);

    virtual cdp_size_t  geometryIndex() const override;
    virtual cdp_int_t   resultId() const override;
    virtual cdp_int_t   stateId() const override;

    void                setGeometryIndex(cdp_size_t geometryIndex);
    void                setResultId(cdp_int_t resultId);
    void                setStateId(cdp_int_t stateId);

private:
    cdp_size_t  m_geometryIndex;
    cdp_int_t   m_resultId;
    cdp_int_t   m_stateId;
};


}  // cdphl

