//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlResultValueGroup.h"

namespace cdphl {



//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void ResultValueGroup::setResults(const cdp_double_t* resultValueArr, cdp_size_t valueDimension, cdp_size_t valueCount)
{
    m_dimension = valueDimension;
    m_valueCount = valueCount;
    m_resultValues.assign(resultValueArr, resultValueArr + (valueCount*valueDimension));
}
    
//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const std::vector<cdp_double_t>& ResultValueGroup::resultValueArr() const
{
    return m_resultValues;
}


//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t ResultValueGroup::valueDimension() const
{
    return m_dimension;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t ResultValueGroup::valueCount() const
{
    return m_valueCount;
}



}  // cdphl
