//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"

#include "CDPResultValueGroup.h"

#include <vector>

namespace cdphl {


//==================================================================================================
//
// 
//
//==================================================================================================
class ResultValueGroup : public CDPResultValueGroup
{
public:
    virtual void                        setResults(const cdp_double_t* resultValueArr, cdp_size_t valueDimension, cdp_size_t valueCount) override;
    
    const std::vector<cdp_double_t>&    resultValueArr() const;
    size_t                              valueDimension() const;
    size_t                              valueCount() const;
    
private:
    std::vector<cdp_double_t>   m_resultValues;
    size_t                      m_dimension;
    size_t                      m_valueCount;
};


}  // cdphl

