//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlSet.h"

namespace cdphl {


//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void Set::addItem(cdp_size_t geometryIndex, cdp_size_t groupIndex, cdp_int_t itemIndex)
{
    m_items.push_back(SetItem(geometryIndex, groupIndex, -1, itemIndex));
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void Set::addItems(cdp_size_t geometryIndex, cdp_size_t groupIndex, const cdp_int_t* itemIndexArr, cdp_size_t itemCount)
{
    for (size_t i = 0; i < itemCount; i++)
    {
        m_items.push_back(SetItem(geometryIndex, groupIndex, -1, itemIndexArr[i]));
    }
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void Set::addAdaptiveGeometryItem(cdp_int_t stateId, cdp_size_t geometryIndex, cdp_size_t groupIndex, cdp_int_t itemIndex)
{
    m_items.push_back(SetItem(geometryIndex, groupIndex, stateId, itemIndex));
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void Set::addAdaptiveGeometryItems(cdp_int_t stateId, cdp_size_t geometryIndex, cdp_size_t groupIndex, const cdp_int_t* itemIndexArr, cdp_size_t itemCount)
{
    for (size_t i = 0; i < itemCount; i++)
    {
        m_items.push_back(SetItem(geometryIndex, groupIndex, stateId, itemIndexArr[i]));
    }
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t Set::itemCount() const
{
    return m_items.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const cdphl::SetItem& Set::item(size_t index) const
{
    return m_items[index];
}


}  // cdphl
