//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"

#include "CDPSet.h"

#include <vector>

namespace cdphl {


//==================================================================================================
//
// 
//
//==================================================================================================
struct SetItem
{
    cdp_size_t  geometryIndex;
    cdp_size_t  groupIndex;
    cdp_int_t   stateId;
    cdp_int_t   itemIndex;

    SetItem(cdp_size_t inGeometryIndex, cdp_size_t inGroupIndex, cdp_int_t inStateId, cdp_int_t inItemIndex)
    :   geometryIndex(inGeometryIndex),
        groupIndex(inGroupIndex),
        stateId(inStateId),
        itemIndex(inItemIndex)
    {}
};



//==================================================================================================
//
// 
//
//==================================================================================================
class Set : public CDPSet
{
public:
    virtual void    addItem(cdp_size_t geometryIndex, cdp_size_t groupIndex, cdp_int_t itemIndex) override;
    virtual void    addItems(cdp_size_t geometryIndex, cdp_size_t groupIndex, const cdp_int_t* itemIndexArr, cdp_size_t itemCount) override;

    virtual void    addAdaptiveGeometryItem(cdp_int_t stateId, cdp_size_t geometryIndex, cdp_size_t groupIndex, cdp_int_t itemIndex) override;
    virtual void    addAdaptiveGeometryItems(cdp_int_t stateId, cdp_size_t geometryIndex, cdp_size_t groupIndex, const cdp_int_t* itemIndexArr, cdp_size_t itemCount) override;

    size_t          itemCount() const;
    const SetItem&  item(size_t index) const;

private:
    std::vector<SetItem>    m_items;
};




}  // cdphl

