//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlTransformations.h"

namespace cdphl {



//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
void Transformations::addGroupTransformation(const cdp_double_t* groupTransformationMatrix)
{
    GroupTransformation groupTrans;

    if (groupTransformationMatrix)
    {
        groupTrans.matrix.assign(groupTransformationMatrix, groupTransformationMatrix + 16);
    }

    m_groupTransformationArr.push_back(groupTrans);
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t Transformations::groupTransformationCount() const
{
    return m_groupTransformationArr.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
std::vector<double> Transformations::groupTransformation(size_t index) const
{
    return m_groupTransformationArr[index].matrix;
}


}  // cdphl
