//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"
#include "CDPTransformations.h"

#include <vector>

namespace cdphl {


//==================================================================================================
//
// 
//
//==================================================================================================
class Transformations : public CDPTransformations
{
public:
    virtual void            addGroupTransformation(const cdp_double_t* groupTransformationMatrix) override;

    size_t                  groupTransformationCount() const;
    std::vector<double>     groupTransformation(size_t index) const;

private:
    struct GroupTransformation
    {
        std::vector<double>  matrix;
    };

    std::vector<GroupTransformation> m_groupTransformationArr;
};


}  // cdphl

