//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPDataProvider.h"

#include "cdphlGeometry.h"
#include "cdphlLogger.h"
#include "cdphlMetaData.h"

#include <string>

namespace cdphl {


//==================================================================================================
//
// 
//
//==================================================================================================
class Validator
{
public:
    Validator(Logger* logger);
    
    bool validate(CDPDataProvider* provider, std::string modelKey);
    
    bool validateMetaData(const cdphl::MetaData& metaData);
    bool validateGeometry(const cdphl::Geometry& geo, const cdphl::GeometryInfo& geoInfo);
    
private:
    static std::vector<cdp_int_t>   getAllStateIds(const cdphl::MetaData& metaData);
    static std::vector<cdp_int_t>   getAllResultIds(const cdphl::MetaData& metaData);
    void logError(const char* format, ...);

private:
    Logger* m_logger;
};

}
