//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "cdphlVisibilityResult.h"
#include "cdphlVisibilityResultValueGroup.h"

namespace cdphl {



//==================================================================================================
//
//
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
VisibilityResult::~VisibilityResult()
{
    for (size_t i = 0; i < m_groupArr.size(); ++i)
    {
        delete m_groupArr[i];
    }
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
CDPVisibilityResultValueGroup* VisibilityResult::addGroup()
{
    VisibilityResultValueGroup* group = new VisibilityResultValueGroup;
    m_groupArr.push_back(group);
        
    return group;
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
size_t VisibilityResult::groupCount() const
{
    return m_groupArr.size();
}

//--------------------------------------------------------------------------------------------------
///
//--------------------------------------------------------------------------------------------------
const VisibilityResultValueGroup& VisibilityResult::group(size_t index) const
{
    return *m_groupArr[index];
}

}  // cdphl
