//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2020, Ceetron AS
//##################################################################################################

#pragma once

#include "cdphlBase.h"

#include "CDPVisibilityResult.h"

#include <vector>

namespace cdphl {

class VisibilityResultValueGroup;


//==================================================================================================
//
// 
//
//==================================================================================================
class VisibilityResult : public CDPVisibilityResult
{
public:
    virtual ~VisibilityResult();
    
    virtual CDPVisibilityResultValueGroup*  addGroup() override;
    
    size_t                                  groupCount() const;
    const VisibilityResultValueGroup&       group(size_t index) const;
    
private:
    std::vector<VisibilityResultValueGroup*> m_groupArr;
};

}  // cdphl
