//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPBaseTypes.h"
#include "CDPDataProviderTypes.h"

class CDPStateInfo;
class CDPResultInfo;
class CDPString;

//==================================================================================================
//
//
//
//==================================================================================================
class CDPChangeNotifications
{
public:
    virtual ~CDPChangeNotifications() {};
    
    virtual void            notifyResultChanged(cdp_int_t resultId) = 0;
    virtual CDPResultInfo*  notifyResultAdded(CDPResultType resultType, cdp_int_t resultId, const CDPString& name, CDPResultMappingType mapping) = 0;
    virtual void            notifyResultDeleted(cdp_int_t resultId) = 0;
    
    virtual void            notifyRigidBodyTransformationsChanged() = 0;

    virtual void            notifyStateMetaDataChanged(cdp_int_t stateId, const CDPString& name, cdp_double_t referenceValue) = 0;
    virtual CDPStateInfo*   notifyStateAdded(cdp_int_t stateId, const CDPString& name, cdp_double_t referenceValue) = 0;
    virtual void            notifyStateDeleted(cdp_int_t stateId) = 0;

    virtual void            notifyGeometryChanged(cdp_size_t geometryIndex) = 0;
};
