//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include <string>
#include "CDPBaseTypes.h"

class CDPDataProvider;
class CDPString;


//==================================================================================================
//
// 
//
//==================================================================================================
class CDPDataProviderInfo
{
public:
    virtual ~CDPDataProviderInfo() {};

    virtual void    setFileDescription(const CDPString& description) = 0;
    virtual void    setFileMask(const CDPString& mask) = 0;

    virtual void    publishInitOptionBool(const CDPString& optionKey, const CDPString& optionDescription, bool defaultValue) = 0;
    virtual void    publishInitOptionDouble(const CDPString& optionKey, const CDPString& optionDescription, cdp_double_t defaultValue) = 0;
    virtual void    publishInitOptionString(const CDPString& optionKey, const CDPString& optionDescription, const CDPString& defaultValue) = 0;
};


//==================================================================================================
//
// 
//
//==================================================================================================
class CDPDataProviderFactory
{
public:
    virtual ~CDPDataProviderFactory() {};

    virtual bool                getProviderInfo(CDPDataProviderInfo* info) = 0;
    virtual bool                isSupportedByProvider(const CDPString& modelKey) = 0;

    virtual CDPDataProvider*    createProviderInstance() = 0;
    virtual void                destroyProviderInstance(CDPDataProvider* instance) = 0;
};
