//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPBaseTypes.h"
#include "CDPDataProviderTypes.h"


//==================================================================================================
//
// 
//
//==================================================================================================
class CDPElementGroup
{
public:
    virtual ~CDPElementGroup() {};

    virtual void addSingleTypeElements(CDPElementType elementType, cdp_size_t elementCount, const cdp_int_t* elementNodeArr, cdp_size_t elementNodeCount, const cdp_int_t* elementIdArr) = 0;
    virtual void addMultipleTypeElements(const CDPElementType* elementTypeArr, cdp_size_t elementCount, const cdp_int_t* elementNodeArr, cdp_size_t elementNodeCount, const cdp_int_t* elementIdArr) = 0;
    virtual void addPolyhedronData(const cdp_ubyte_t* numNodesPerPolyhedronArr, const cdp_ubyte_t* numFacesPerPolyhedronArr, cdp_size_t polyhedronCount, const cdp_ubyte_t* numNodesPerFaceArr, cdp_size_t totalFaceCount, const cdp_int_t* faceNodeIndicesArr, cdp_size_t faceNodeIndicesCount) = 0;

    virtual void setElementPartIds(const cdp_int_t* partIdArr, cdp_size_t elementCount) = 0;

    virtual void setPrescribedElementOrdering(const cdp_int_t* elementTargetIndices, cdp_size_t elementCount) = 0;
};

