//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2020, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPBaseTypes.h"
#include "CDPString.h"

//==================================================================================================
//
// 
//
//==================================================================================================
class CDPInitOptions
{
public:
    virtual bool                hasKey(const CDPString& optionKey) const = 0;       ///< Check if the option with the given key exists
    
    virtual cdp_double_t        doubleValue(const CDPString& optionKey) const = 0;  ///< Get the double value of the option with the given key
    virtual bool                boolValue(const CDPString& optionKey) const = 0;    ///< Get the bool value of the option with the given key
    virtual const CDPString&    stringValue(const CDPString& optionKey) const = 0;  ///< Get the string value of the option with the given key
};
