//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include <string>


//==================================================================================================
//
// 
//
//==================================================================================================
class CDPLogHelper
{
public:
    typedef void(*RawLogFunc)(int level, const char* message);

public:
    inline CDPLogHelper(RawLogFunc rawLogFunc);

    inline void     logError(const std::string& message);
    inline void     logWarning(const std::string& message);
    inline void     logInfo(const std::string& message);
    inline void     logDebug(const std::string& message);

private:
    RawLogFunc m_logFunc;
};




#include "CDPLogHelper.inl"

