//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "CDPNodeGroup.h"

//==================================================================================================
///
/// \class CDPNodeGroup
///
/// A group of nodes that is used by one or more [element groups](@ref CDPElementGroup).
/// The node group consists of node coordinates (x,y,z) and an optional id per node.
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// Set the nodes in this group.
/// 
/// The nodes are specified with an array of interleaved 3d coordinates, so the array contains: 
/// <x0, y0, z0, x1, y1, z1, ...>. 
/// 
/// nodeCount is the number of nodes, so the array must be 3*nodeCount long.
//--------------------------------------------------------------------------------------------------
void CDPNodeGroup::setNodes(const cdp_double_t* nodeArr, cdp_size_t nodeCount)
{
}

//--------------------------------------------------------------------------------------------------
/// Specify an optional id per node in this group
/// 
/// Use this method to set the id of the nodes. nodeIdArr must be of size nodeCount and the nodeCount
/// must match the number of nodes in the group.
//--------------------------------------------------------------------------------------------------
void CDPNodeGroup::setNodeIds(const cdp_int_t* nodeIdArr, cdp_size_t nodeCount)
{
}

//--------------------------------------------------------------------------------------------------
/// Returns the zero based index of this node group.
/// 
/// Use this to set the node index when adding element groups with CDPGeometry::addElementGroup
//--------------------------------------------------------------------------------------------------
cdp_size_t CDPNodeGroup::groupIndex() const
{
    return 0;
}
