//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "CDPResultValueGroup.h"

//==================================================================================================
///
/// \class CDPResultValueGroup
///
/// The results for either a node or element group.
/// 
/// For [per node](@ref CDP_PER_NODE) results, these are results for a corresponding 
/// [node group](@ref CDPNodeGroup).
/// 
/// For [per element](@ref CDP_PER_ELEMENT), [per element node](@ref CDP_PER_ELEMENT_NODE) or 
/// [per element surface](@ref CDP_PER_ELEMENT_SURFACE) results, these are results for a 
/// corresponding [element group](@ref CDPElementGroup).
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// Set the results for this group.
/// 
/// Use this method to specify the results for the node/element group.
/// 
/// The size of \a resultValueArr is \a valueDimension * \a valueCount.
/// 
/// For per node (@ref CDP_PER_NODE) results, you must specify one value (1 or more components per value depending on the dimension 
/// of the result) for each node in the associated node group.
/// 
/// For per element (@ref CDP_PER_ELEMENT), element node (@ref CDP_PER_ELEMENT_NODE) or 
/// element surface results (@ref CDP_PER_ELEMENT_SURFACE), you must specify one value (1 or more 
/// components per value depending on the dimension of the result) for each element, element node or 
/// element surface in the associated element group.
//--------------------------------------------------------------------------------------------------
void CDPResultValueGroup::setResults(const cdp_double_t* resultValueArr, cdp_size_t valueDimension, cdp_size_t valueCount)
{

}
