//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "CDPSet.h"

//==================================================================================================
///
/// \class CDPSet
/// 
/// This class defines the items of a set
/// 
/// A set item is specified by:
/// - geometry index
/// - group index
/// - item index
/// - (optional) state id (for adaptive geometries)
/// 
/// If you are using adaptive geometries, you should use the addAdaptiveGeometryItem or 
/// addAdaptiveGeometryItems methods to add items to the set.
/// 
/// \note Currently, only element sets are supported 
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// Add an item with the given geometry index, group index and item index to the set.
/// 
/// As only element sets are currently supported, item index is element index.
/// 
/// \note Only use this method if you are refering to a non-adaptive geometry.
//--------------------------------------------------------------------------------------------------
void CDPSet::addItem(cdp_size_t geometryIndex, cdp_size_t groupIndex, cdp_int_t itemIndex)
{

}


//--------------------------------------------------------------------------------------------------
/// Add items with the given geometry index, group index and item indices to the set.
/// 
/// This is useful for adding many items (elements) to the set from a given element group.
/// 
/// \note Only use this method if you are refering to a non-adaptive geometry.
//--------------------------------------------------------------------------------------------------
void CDPSet::addItems(cdp_size_t geometryIndex, cdp_size_t groupIndex, const cdp_int_t* itemIndexArr, cdp_size_t itemCount)
{

}


//--------------------------------------------------------------------------------------------------
/// Add an item with the given state id, geometry index, group index and item index to the set.
/// 
/// As only element sets are currently supported, item index is element index.
/// 
/// \note Only use this method if you are refering to an adaptive geometry.
//--------------------------------------------------------------------------------------------------
void CDPSet::addAdaptiveGeometryItem(cdp_int_t stateId, cdp_size_t geometryIndex, cdp_size_t groupIndex, cdp_int_t itemIndex)
{

}


//--------------------------------------------------------------------------------------------------
/// Add items with the given state id, geometry index, group index and item indices to the set.
/// 
/// This is useful for adding many items (elements) to the set from a given element group.
/// 
/// \note Only use this method if you are refering to an adaptive geometry.
//--------------------------------------------------------------------------------------------------
void CDPSet::addAdaptiveGeometryItems(cdp_int_t stateId, cdp_size_t geometryIndex, cdp_size_t groupIndex, const cdp_int_t* itemIndexArr, cdp_size_t itemCount)
{

}
