//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPBaseTypes.h"

#include <cstddef>
#include <cstring>


//==================================================================================================
//
// 
//
//==================================================================================================
class CDPString
{
public:
    inline CDPString();
    inline CDPString(const CDPString& other);
    inline ~CDPString();

    inline CDPString&           operator=(const CDPString& rhs);

    inline const cdp_char_t*    utf8() const;
    inline cdp_size_t           byteCount() const;

    inline static CDPString     fromUtf8(const cdp_char_t* utf8Ptr);
    inline static CDPString     fromChar(const cdp_char_t* charPtr);
    
    inline static const CDPString& emptyString();
    
private:
    cdp_char_t* m_str;
};


#include "CDPString.inl"


