//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#include "CDPTransformations.h"

//==================================================================================================
///
/// \class CDPTransformations
/// 
/// The rigid body transformation result for a given geometry in a given state. 
/// 
/// You need to add one transformation matrix for each element group in the corresponding 
/// geometry. For parts without transformations, add an identity matrix.
/// 
/// The matching is done by index, so the result must have as many groups as there are element/node
/// groups in the corresponding geometry. 
/// 
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// Add a transformation matrix to the result.
/// 
/// groupTransformationMatrix should be an array with 16 elements specifying the 4*4 transformation 
/// matrix for the corresponding element group.
/// 
/// The matrix must be specified in column, then row order:
/// 
///     | v0  v4  v8  v12 |
///     | v1  v5  v9  v13 |
///     | v2  v6  v10 v14 |
///     | v3  v7  v11 v15 |
//--------------------------------------------------------------------------------------------------
void CDPTransformations::addGroupTransformation(const cdp_double_t* groupTransformationMatrix)
{

}
