//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2018, Ceetron AS
//##################################################################################################

#pragma once

#include "CDPBaseTypes.h"


//==================================================================================================
//
// 
//
//==================================================================================================
class CDPVec3
{
public:
    inline CDPVec3();
    inline CDPVec3(const CDPVec3& other);
    inline CDPVec3(double x, double y, double z);

    inline CDPVec3&         operator=(const CDPVec3& rhs);

    inline const CDPVec3    operator+(const CDPVec3& rhs) const;
    inline const CDPVec3    operator-(const CDPVec3& rhs) const;

    inline double           operator*(const CDPVec3& rhs) const;
    inline const CDPVec3    operator^(const CDPVec3& rhs) const;

    inline const double&    x() const;
    inline const double&    y() const;
    inline const double&    z() const;
    inline double&          x();
    inline double&          y();
    inline double&          z();
    inline void             set(double x, double y, double z);

private:
    double m_v[3];
};


#include "CDPVec3.inl"


