//##################################################################################################
//
//  Ceetron Data Provider Framework
//
//  --------------------------------------------------------------------------------------------
//  Copyright (C) 2020, Ceetron AS
//##################################################################################################

#include "CDPVisibilityResult.h"

//==================================================================================================
///
/// \class CDPVisibilityResult
///
/// The visibility result for a given geometry in a given state.
/// 
/// This class contains an array of [groups](@ref CDPResultValueGroup). The groups are matched with the 
/// corresponding element group.
/// 
/// The matching is done by index, so the result must have as many groups as there are element
/// groups in the corresponding geometry. 
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// Add a visibility result value group to this result.
/// 
/// Use this method to add the group, and populate the results for the group in the returned 
/// CDPVisibilityResultValueGroup object.
//--------------------------------------------------------------------------------------------------
CDPVisibilityResultValueGroup* CDPVisibilityResult::addGroup()
{
    return NULL;
}
