
#include "MinimalProviderFactory.h"
#include "MinimalProvider.h"

#include "CDPAll.h"

#include <cstdio>
#include <string.h>





//==================================================================================================
//
// 
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
MinimalProviderFactory::MinimalProviderFactory()
{
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
MinimalProviderFactory::~MinimalProviderFactory()
{
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool MinimalProviderFactory::getProviderInfo(CDPDataProviderInfo* info)
{
    info->setFileDescription(CDPString::fromChar("Minimal Provider"));
    info->setFileMask(CDPString::fromChar("MINIMAL"));

    return true;
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool MinimalProviderFactory::isSupportedByProvider(const CDPString& modelKey)
{
    std::string stdModelKey = modelKey.utf8();
    if (stdModelKey.find("MINIMAL") == 0)
    {
        return true;
    }

    return false;
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
CDPDataProvider* MinimalProviderFactory::createProviderInstance()
{
    return new MinimalProvider;
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
void MinimalProviderFactory::destroyProviderInstance(CDPDataProvider* instance)
{
    if (instance)
    {
        delete instance;
    }
}
