
#include "PolyhedronProviderFactory.h"

#include "CDPAll.h"

#include <cstdio>
#include <string.h>


//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
static void destroyProviderFactory(CDPDataProviderFactory* factoryPtr)
{
    if (factoryPtr)
    {
        delete factoryPtr;
    }
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
static void pluginExitFunc()
{
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
extern "C" CDP_PLUGIN_EXPORT CDP_PluginExitFunc initializeDataProviderPlugin(const CDP_FrameworkServices* params)
{
    CDPLogHelper logger(params->logFunc);

    logger.logDebug("initializeDataProviderPlugin - PolyhedronPlugin");
    logger.logDebug("  compiler info: " + CDPUtils::compilerInfoString());

    params->setPluginInfoFunc("name", "PolyhedronPlugin");
    params->setPluginInfoFunc("compiler", CDPUtils::compilerInfoString().c_str());

    CDP_RegisterProviderParams rp;
    rp.pluginApiMajorVer = CDP_API_MAJOR_VER;
    rp.pluginApiMinorVer = CDP_API_MINOR_VER;
    rp.providerFactoryObj = new PolyhedronProviderFactory();
    rp.destroyProviderFactoryFunc = destroyProviderFactory;

    int res = params->registerProviderFunc("PolyhedronProvider", &rp);
    if (res == CDP_RET_FAIL)
    {
        return NULL;
    }

    return pluginExitFunc;
}
