#pragma once

#include "CDPDataProvider.h"

// Remove override keyword if not supported
#ifndef CDP_SUPPORTS_OVERRIDE_KEYWORD
#define override
#endif

//==================================================================================================
//
// 
//
//==================================================================================================
class PolyhedronProvider : public CDPDataProvider
{
public:
    PolyhedronProvider();
    ~PolyhedronProvider();

    virtual bool init(const CDPString& modelKey, const CDPInitOptions& initOptions) override;
    virtual void close() override;

    virtual bool getMetaData(CDPMetaData* metaData) override;
    virtual bool getGeometry(const CDPGeometrySpec& spec, CDPGeometry* geometry) override;
    
    virtual bool getSet(cdp_int_t setId, CDPSet* set) override;

    virtual bool getResult(const CDPResultSpec& spec, CDPResult* result) override;
    virtual bool getRigidBodyTransformations(cdp_size_t geometryIndex, cdp_int_t stateId, CDPTransformations* transformations) override;
    virtual bool getElementVisibilityResult(cdp_size_t geometryIndex, cdp_int_t stateId, CDPVisibilityResult* result) override { return false; };
    
    virtual void pollForChanges(CDPChangeNotifications* changeNotifications) override;
};
