
#include "PolyhedronProviderFactory.h"
#include "PolyhedronProvider.h"

#include "CDPAll.h"

#include <cstdio>
#include <string.h>





//==================================================================================================
//
// 
//
//==================================================================================================

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
PolyhedronProviderFactory::PolyhedronProviderFactory()
{
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
PolyhedronProviderFactory::~PolyhedronProviderFactory()
{
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool PolyhedronProviderFactory::getProviderInfo(CDPDataProviderInfo* info)
{
    info->setFileDescription(CDPString::fromChar("Polyhedron Provider"));
    info->setFileMask(CDPString::fromChar("POLYHEDRON"));

    return true;
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
bool PolyhedronProviderFactory::isSupportedByProvider(const CDPString& modelKey)
{
    std::string stdModelKey = modelKey.utf8();
    if (stdModelKey.find("POLYHEDRON") == 0)
    {
        return true;
    }

    return false;
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
CDPDataProvider* PolyhedronProviderFactory::createProviderInstance()
{
    return new PolyhedronProvider;
}

//--------------------------------------------------------------------------------------------------
/// 
//--------------------------------------------------------------------------------------------------
void PolyhedronProviderFactory::destroyProviderInstance(CDPDataProvider* instance)
{
    if (instance)
    {
        delete instance;
    }
}
